//+------------------------------------------------------------------+
//|                                                Donchian channels |
//|                                            Donchian channels.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1 Green
#property indicator_color2 Red
#property indicator_color3 LimeGreen
#property indicator_color4 Red
#property indicator_color5 Red
#property indicator_style1 STYLE_DOT
#property indicator_style2 STYLE_DOT
#property indicator_width3 2
#property indicator_width4 2
#property indicator_width5 2


//
//
//
//
//

extern int  ChannelPeriod = 21;
extern int  HighLowShift  = 1;
extern bool ShowMiddle    = true;

double buffer1[];
double buffer2[];
double buffer3[];
double buffer4[];
double buffer5[];
double price[];
double trend[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,buffer1);
   SetIndexBuffer(1,buffer2);
   SetIndexBuffer(2,buffer3);
   SetIndexBuffer(3,buffer4);
   SetIndexBuffer(4,buffer5);
   SetIndexBuffer(5,price);
   SetIndexBuffer(6,trend);
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double work[][3];
#define _dcUpper  0
#define _dcMiddle 1
#define _dcLower  2

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int i,r,limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

      if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);
      if (trend[limit]==-1) CleanPoint(limit,buffer4,buffer5);
      for (i=limit,r=Bars-i-1;i>=0;i--,r++)
      {
         work[r][_dcUpper]  = High[Highest(NULL,0,MODE_HIGH,ChannelPeriod,i+HighLowShift)];
         work[r][_dcLower]  = Low[Lowest(NULL,0,MODE_LOW,ChannelPeriod,i+HighLowShift)];
         work[r][_dcMiddle] = (work[r][_dcUpper]+work[r][_dcLower])/2.0;
         
         //
         //
         //
         //
         //
         
         buffer1[i] = work[r][_dcUpper];
         buffer2[i] = work[r][_dcLower];
         buffer4[i] = EMPTY_VALUE;
         buffer5[i] = EMPTY_VALUE;
         trend[i]   = trend[i+1];

            if (work[r][_dcMiddle]>work[r-1][_dcMiddle]) trend[i] =  1;
            if (work[r][_dcMiddle]<work[r-1][_dcMiddle]) trend[i] = -1;
            if (ShowMiddle)
            {
               buffer3[i] = (buffer1[i]+buffer2[i])/2; if (trend[i]==-1) PlotPoint(i,buffer4,buffer5,buffer3);
            }
      }            
      return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if (i>Bars-3) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}
void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>Bars-3) return;
   if (first[i+1] == EMPTY_VALUE)
         if (first[i+2] == EMPTY_VALUE) 
               { first[i]  = from[i]; first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
         else  { second[i] = from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else        { first[i]  = from[i];                          second[i] = EMPTY_VALUE; }
}